'use strict';

var cond = require('./cond');

/**
 * "Maybe" rule modifier:
 * Only validate the value using the given rule if the value is not null or undefined.
 *
 * @param rule
 *
 * @returns {function}
 */
module.exports = function (rule) {
  return function (args) {
    return cond(function (val) {
      return val !== null && val !== undefined;
    }, rule, null)(args);
  };
};