'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _require = require('lodash'),
    isString = _require.isString;

/**
 * "Format" rule
 *
 * @param {RegExp} pattern
 * @param error
 */


module.exports = function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        pattern = _ref.pattern,
        _ref$error = _ref.error,
        error = _ref$error === undefined ? 'Incorrectly formatted' : _ref$error;

    if (!(pattern instanceof RegExp)) throw new TypeError('Expected "pattern" to be an instance of RegExp, ' + (typeof pattern === 'undefined' ? 'undefined' : _typeof(pattern)) + ' given.');

    return function (value) {
        if (!isString(value)) return error + ' (expected a string).';
        return pattern.test(value) ? null : error;
    };
};