'use strict';

var _require = require('lodash'),
    isString = _require.isString;

/**
 * String "length" rule
 *
 * @param min
 * @param max
 * @param is
 * @param minError
 * @param maxError
 * @param isError
 */


module.exports = function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$min = _ref.min,
        min = _ref$min === undefined ? null : _ref$min,
        _ref$max = _ref.max,
        max = _ref$max === undefined ? null : _ref$max,
        _ref$is = _ref.is,
        is = _ref$is === undefined ? null : _ref$is,
        _ref$minError = _ref.minError,
        minError = _ref$minError === undefined ? function (min) {
        return 'Must be at least ' + min + ' characters long.';
    } : _ref$minError,
        _ref$maxError = _ref.maxError,
        maxError = _ref$maxError === undefined ? function (max) {
        return 'Can\'t be more than ' + max + ' characters long.';
    } : _ref$maxError,
        _ref$isError = _ref.isError,
        isError = _ref$isError === undefined ? function (len) {
        return 'Must be exactly ' + len + ' characters long.';
    } : _ref$isError;

    if (is && (min || max)) throw new TypeError('You cannot use both "is" and either "min" or "max" on the "length" rule');

    if (min && max && min > max) throw new TypeError('"min" cannot be higher than "max" on the "length" rule');

    return function (val) {
        if (!isString(val)) return 'Expected a string.';
        var length = val.length;
        if (is && length !== is) return isError(is);
        if (min && length < min) return minError(min);
        if (max && length > max) return maxError(max);
        return null;
    };
};