'use strict';

var _require = require('lodash'),
    includes = _require.includes;

/**
 * "Not in" rule (require the field to have a value that is not included in the given set of values)
 *
 * @param {String[]} values
 * @param {Function} error
 */


module.exports = function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      values = _ref.values,
      _ref$error = _ref.error,
      error = _ref$error === undefined ? function (values) {
    return 'Cannot be one of: ' + values.join(', ') + '.';
  } : _ref$error;

  return function (value) {
    return !includes(values, value) ? null : error(values);
  };
};