'use strict';

var _require = require('lodash'),
    isObject = _require.isObject,
    isEmpty = _require.isEmpty,
    size = _require.size,
    mapValues = _require.mapValues,
    pickBy = _require.pickBy;

var shake = function shake(obj) {

    if (!isObject(obj)) return isEmpty(obj) ? null : obj;

    var shaken = pickBy(mapValues(obj, shake));

    if (!size(shaken)) return null;

    return shaken;
};

module.exports = shake;