'use strict';

var ValidationError = require('../error/ValidationError');

var pTry = require('./pTry');

/**
 * Given the function that returns or resolves to a validation result,
 * create a function that will throw a ValidationError if that validation fails
 * @param runRule
 */
module.exports = function (runRule) {
  return pTry(runRule).then(function (result) {
    if (result !== null) throw new ValidationError(result);
  });
};